package th.co.dv.p2p.customs.base.models

import com.fasterxml.jackson.annotation.JsonIgnoreProperties
import com.fasterxml.jackson.annotation.JsonInclude
import com.fasterxml.jackson.annotation.JsonProperty
import org.codehaus.jackson.map.annotate.JsonSerialize
import java.math.BigDecimal

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonSerialize
data class DebitNoteModel(

        val vendorNumber: String? = null,
        val vendorBranchCode: String? = null,
        val vendorBranchName: String? = null,
        val vendorName: String? = null,
        val vendorTaxNumber: String? = null,
        val vendorAddress: String? = null,
        val vendorTelephone: String? = null,
        val businessPlace: String? = null,
        val companyCode: String? = null,
        val companyName: String? = null,
        val companyTaxNumber: String? = null,
        val companyBranchCode: String? = null,
        val companyBranchName: String? = null,
        val companyAddress: String? = null,
        val companyTelephone: String? = null,
        val externalId: String? = null,
        val invoiceLinearId: String? = null,
        val invoiceExternalId: String? =null,
        val debitNoteDate: String? = null,
        val paymentTermCode: String? = null,
        val paymentTermDesc: String? = null,
        val paymentTermDays: Long? = null,
        val dueDate: String? = null,
        val initialDueDate: String? = null,
        val dueDateLastEditedReason: String? = null,
        val dueDateLastEditedBy: String? = null,
        val dueDateLastEditedDate: String? = null,
        val dueDateIsLocked: Boolean? = false,
        val debitNoteCreatedDate: String? = null,
        val listTotal: BigDecimal? = null,
        val totalDiscount: BigDecimal? = null,
        val totalSurcharge: BigDecimal? = null,
        val subTotal: BigDecimal? = null,
        val vatTotal: BigDecimal? = null,
        val total: BigDecimal? = null,
        val withholdingTaxTotal: BigDecimal? = null,
        val totalPayable: BigDecimal? = null,
        val currency: String? = null,
        val buyer: PartyModel? = null,
        val seller: PartyModel? = null,
        val bank: PartyModel? = null,
        val baselineDate: String? = null,
        val receiptNumber: String? = null,
        val receiptDate: String? = null,
        val paymentFee: BigDecimal? = null,
        val reason: String? = null,
        val debitNoteItems: List<DebitNoteItemModel> = emptyList(),
        val status: String? = null,
        val lifecycle: String? = null,
        val linearId: String? = null,
        val buyerApprovedDate: String? = null,
        val buyerApprovedRemark: String? = null,
        val buyerApprovedUser: String? = null,
        val buyerRejectedDate: String? = null,
        val buyerRejectedRemark: String? = null,
        val buyerRejectedUser: String? = null,
        val cancelledUser: String? = null,
        val cancelledDate: String? = null,
        val cancelledRemark: String? = null,
        val cancelledCode: String? = null,
        val cancelledInvoiceNumber: String? = null,
        val cancelledVendorTaxNumber: String? = null,
        val cancelledInvoiceDate: String? = null,
        val calculatedDate: String? = null,
        val customisedFields: Map<String, Any> = emptyMap(),
        val customisedFieldsUpdatedDate: String? = null,
        val currentAuthority: DelegationOfAuthorityModel? = null,
        val nextAuthority: DelegationOfAuthorityModel? = null,
        val previousAuthority: DelegationOfAuthorityModel? = null,
        val delegatedAuthorities: List<DelegationOfAuthorityModel>? = null,
        val taggedCreditNotes: List<TaggedDocumentModel>? = null,
        val paymentDate: String? = null,
        val paymentItemLinearId: String? = null,
        val paymentIsSuccessful: Boolean? = null,
        val paymentStatusUpdateDate: String? = null,
        val fileAttachments: List<FileAttachmentModel>? = listOf(),
        val paymentReferenceNumber: String? = null,
        val postingStatus: String? = null,
        val debitNotePostingUpdatedDate: String? = null,
        val lastEditedBy: String? = null,
        val lastEditedDate: String? = null,
        val referenceField1: String? = null,
        val referenceField2: String? = null,
        val referenceField3: String? = null,
        val referenceField4: String? = null,
        val referenceField5: String? = null,
        // to handle serialising/deserialising `is` keyword, else `is` will be stripped away after writing to JSON
        @get:JsonProperty("isETaxDebitNote")
        val isETaxDebitNote: Boolean? = null,
        val adjustmentType: String? = null,
        val invoiceFinancing: Char? = null,
        val invoice: InvoiceModel? = null,
        var withholdingTaxCalculationPoint: String? = null,

        var requestExternalId: String? = null,
        var requestLinearId: String? = null
)
